<!--
SPDX-FileCopyrightText: 2023 Alex Lemna <git@alexanderlemna.com>

SPDX-License-Identifier: CC0-1.0
-->

# Todo

## versions prior to stable release

### version `0.0.1`

- [x] define versioning policy in `developer tasks/versioning.md`
- [x] rename to `auldcommons`
- [x] define license, put it in repository root and `pyproject.toml`
    - see: [link](https://www.exygy.com/blog/which-license-should-i-use-mit-vs-apache-vs-gpl)
- [x] add license to each file
- [x] add README for root directory
- [x] define all common dev tasks in `developer tasks/README.md`
- [x] add something basic for release notes (changelog)

*Tentatively publishing on PyPI by 2023-07-16, third Sunday in July.*

### version `0.0.2`

- [ ] ensure pytest coverage of `AuldDict`
- [ ] add tox

*Tentatively publishing on PyPI by 2023-07-26, last Wednesday in July.*

### version `0.1.0` onwards

- [ ] finish `AuldDict`

*Tentatively publishing on PyPI by 2023-07-30, last Sunday in July.*

### later versions, prior to `1.0.0`

- [ ] add `interrogate` and `coverage`
- [ ] set up `invoke`
- [ ] setup Quarto for documentation (see: [link](https://github.com/machow/quartodoc)) (and maybe see: [link](https://stackoverflow.com/questions/10343998/sphinx-public-api-documentation))
- [ ] add docstrings for all public API
- [ ] generate documentation
- [ ] fill out README
- [ ] review [PEP 0639](https://peps.python.org/pep-0639/) to see if we need to change anything
